package com.flyfish.framework.context;

import com.flyfish.framework.domain.po.User;
import org.springframework.stereotype.Component;

import java.util.Optional;

/**
 * 用户上下文，用于创建时使用的上下文
 *
 * @author wybab
 */
@Component
public final class UserContext {

    private static UserContext instance;
    private ThreadLocal<User> userThreadLocal = new ThreadLocal<>();

    public UserContext() {
        instance = this;
    }

    public static Optional<UserContext> sharedContext() {
        return Optional.ofNullable(instance);
    }

    public User currentUser() {
        return userThreadLocal.get();
    }

    public void setUser(User user) {
        userThreadLocal.set(user);
    }

    public void clear() {
        userThreadLocal.remove();
    }
}
