package com.flyfish.framework.service;

import org.springframework.security.core.AuthenticationException;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.util.MultiValueMap;

/**
 * 认证日志者
 *
 * @author wangyu
 */
public interface AuthenticationLogger {

    /**
     * 记录成功
     *
     * @param user 用户
     */
    void success(UserDetails user);

    /**
     * 记录失败
     *
     * @param form      表单
     * @param exception 错误异常
     */
    void failure(MultiValueMap<String, String> form, AuthenticationException exception);

    /**
     * 记录退出
     *
     * @param user 用户
     */
    void logout(UserDetails user);
}
